/*

///////////////////////////////////////////////////////////////////////////////////
Modded Version : For WII with D2B Driver Chip
    Mod Author : AloneTrio 
          Date : 12/02/2007  22:30
///////////////////////////////////////////////////////////////////////////////////


The Cable for the GC:

 --------------
|10  9  8  7  6|
|              |
| 1  2  3  4  5|
 --------------

PortNr	CN302 Pin	MN10200 Pin	Use						LPT Port

	1				GND					--	GND	 (18-25)
	
P80	7		46		Port
P81	6		47		Port				
P82	2		48		SBT3			(Clock)		->	Busy     (11)
P83	4		49		TM4IO input SBI3	(Input)		<-	Strobe    (1)
P84	3		50		SBO3 output		(Output)	<-	AutoFeed (14)
P85	(?)		51(?)		TM9IOA input ST4 input 
P55	(?)		(?)		SBO0
P42 	(?)		(?)		TM5IOA
	5
	8
	9
	10

The Cable for the WII:

	- 1 -
	2 3 4
	- 5 6
	
  X   Y

	MN10200 Pin	Use			LPT Port
	
1	?
2	?
4	67		SBT1 (Clock)	<-	Strobe    (1)
6	68		SBI1 (Input)	<-	AutoFeed (14)
3	69		SBO1 (Output)	->	Busy     (11)
5	70		RDY

X			GND		--	GND	 (18-25)
Y			+3.3V

*/

/*

R[0]	-> (drv 06) 40eb48
R[1]	            40eb49
R[2]	            40eb4a
R[3]	            40eb4b
R[4]	            40eb4c
R[5]	            40eb4d
R[6]	            40eb4e
R[7]                40eb4f
R[8]                40eb50
R[9]                40eb51

--------------------------------------------------------------
SERIAL_CMD_FF:
--------------------------------------------------------------
Read memory, does memcopy to 0x40eb54. max 0x20 bytes. Then 
transmits over serial if. 

R[0]	FF
R[1]	00
R[2]	scr addr M
R[3]	scr addr L
R[4]	0
R[5]	scr addr H
R[6]	0
R[7]	0
R[8]	nr of bytes to write
R[9]	0

---------------------------------------------------------
SERIAL_CMD_FE:
---------------------------------------------------------
Writes one or two bytes to memory

R[0]	FE
R[1]	00
R[2]	ADDR_M
R[3]	ADDR_L
R[4]	BYTE_1
R[5]	ADDR_H
R[6]	BYTE_2
R[7]	0
R[8]	1-2	nr of bytes to write
R[9]	0

--------------------------------------------------------------
SERIAL_CMD_FD:
--------------------------------------------------------------
Dumps some interesting memory locations to [40D600,,]

R[0]	FD
R[1]	00
R[2]	z
R[3]	z
R[4]	z
R[5]	z
R[6]	z
R[7]	z
R[8]	z
R[9]	z

 memcpy([40D600,,], [8136,,], 0x48);
 *(u24 *) [40D648,,] = [8136,,];
 *(u8 *) [40D64B,,] = 0;
 *(u24 *) [40D64C,,] = *(u24 *)[817E,,];
 *(u8 *) [40D64F,,] = 0;
 *(u24 *) [40D650,,] = *(u24 *)[8182,,];
 *(u8 *) [40D653,,] = 0;
 *(u16 *) [40D654,,] = *(u16 *)[818E,,];
 *(u16 *) [40D656,,] = *(u16 *)[8120,,];
 memcpy([40D658,,], [819E,,], 0x10);
 memcpy([40D668,,], [81AE,,], 0x10);
 memcpy([40D678,,], [81BE,,], 0x10);
 memcpy([40D688,,], [81CE,,], 0x10);
 *(u16 *) [40D698,,] = *(u16 *)[80F4,,];
 memcpy([40D69A,,], [80B4,,], 0x0c);
 memcpy([40D6A6,,], [80C0,,], 0x18);
 memcpy([40D6BE,,], [80D8,,], 0x04);
 memcpy([40D6C2,,], [8116,,], 0x04);
 memcpy([40D6C6,,], [80FE,,], 0x1e);
 memcpy([40D6E4,,], [40EB7E,,], 0x10);
 *(u16 *) [40D6F4,,] = *(u16 *)[811C,,];

--------------------------------------------------------------
SERIAL_CMD_FC:
--------------------------------------------------------------
if R4 != 0, drive does not reply anymore (to be more exact it 
replies zeroes on dma tranfers) You can bring it back to 
life with R4  = 0. Also used on init with R4 = 0. Probably
something like "Enable DI"    *confirm* 

R[0]	FC
R[1]	00
R[2]	A5
R[3]	5A
R[4]	0-1
R[5]	FF
R[6]	0
R[7]	0
R[8]	0
R[9]	0

--------------------------------------------------------------
SERIAL_CMD_FB:
--------------------------------------------------------------
Writes val to [81E5,,] and [40000B,,] ???

R[0]	FB	
R[1]	00
R[2]	z
R[3]	z
R[4]	val
R[5]	z
R[6]	z
R[7]	z
R[8]	z
R[9]	z

gc-drive 06:
	  *81d9=val
	*40000B=val

----------------------------------------------
SERIAL_CMD_FA:
----------------------------------------------

----------------------------------------------
SERIAL_CMD_F9:
----------------------------------------------
Same as DbgSetReadOptions

ReadConfig

can be set with FE 10 or a serial command. 

in both cases, you set 
FE 10 00 00 xx xx yy yy ...

there are two words, xxxx and yyyy (Big endian!). xxxx are the bits which are CLEARED from the 
read config and YYYY are the bits which are SET. (so the formula is: newReadConfig = (OldReadConfig &~ xxxx) | yyyy) 

anyway, there are several bits: 

0001 controls 00 30 03/00 ... Low level command. if set, byte #2 is 03, otherwise it's 00 
0002 and 0004 influence the 00 38 LLCommand - when 0002 is not set, 0x24 is set. when 0004 is not set, 0x03 is set. 
0008 is checked at [,,85F47] 
0040 disables some error checks at [,,87A54] 
0080 is checked at [,,85C9B] 
0100 is checked at [,,80E7C] 
0200 set ReadSectorContext flags 0002, 

0002 also disables a read-error check at [,,86FDB], 0x1003 and 0x1004

----------------------------------------------
SERIAL_CMD_F8:
----------------------------------------------
Allows some limited HLECommand execution

R[0]	F8
R[1]	00
R[2]	A5
R[3]	5A
R[4]	0-1
R[5]	FF
R[6]	0
R[7]	0
R[8]	0
R[9]	0

*/

#ifndef __CN302_H__
#define __CN302_H__

#include <stdint.h>

typedef void (*cn302_progress_callback_t)(int x,int size);

int cn302_init(int clockdelay,int cmddelay,int syncdelay);
int cn302_close(void);
void cn302_set_progresscallback(cn302_progress_callback_t callback);

int cn302_sync_queue(int syncbits);

int cn302_read_block(int offset, int size, uint8_t* buffer);
int cn302_write_block(int offset, int size, uint8_t* buffer);

int cn302_poke_byte(int offset, uint8_t val);
int cn302_peek_byte(int offset, uint8_t *val);

int cn302_gc_unlock_debugmode(int drive);
int cn302_wii_unlock_debugmode(int drive);

int cn302_detect_console(int *console);
int cn302_detect_drive(int console,int *drive,char *inquiry);


#define cn302_resync()	cn302_sync_queue(64*16)

#endif /* __CN302_H__ */
