
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <sys/fcntl.h>
#include <fcntl.h>
#include <linux/parport.h>
#include <linux/ppdev.h>
#include <time.h>
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

//#define DEBUG_LPTPORT

#ifdef DEBUG_LPTPORT
#define dbgprintf(_x_)	printf _x_
#else
#define dbgprintf(_x_)
#endif

int lptport = 0;

int lptport_init(void)
{
	lptport = open("/dev/parport0",O_RDWR);

	if (lptport <= 0)
	{
		return -1;
	}
	
	ioctl(lptport,PPCLAIM);
	return 1;
}

int lptport_close(void)
{
	return close(lptport);
}

int lptport_getstatus_busy(void)
{
	uint8_t inbit;
	uint8_t buffer;
	ioctl(lptport, PPRSTATUS, &buffer);
	inbit = 0;
	if (buffer & PARPORT_STATUS_BUSY) inbit = 1;
	return inbit;
}

int lptport_setcontrol_strobe(int outbit)
{
	struct ppdev_frob_struct output;
	output.mask = PARPORT_CONTROL_STROBE;
	if(outbit) output.val = PARPORT_CONTROL_STROBE;
	else output.val=0;
	return ioctl(lptport, PPFCONTROL, &output);
}

int lptport_setcontrol_autofeed(int outbit)
{
	struct ppdev_frob_struct output;
	output.mask = PARPORT_CONTROL_AUTOFD;
	if(outbit) output.val = PARPORT_CONTROL_AUTOFD;
	else output.val=0;
	return ioctl(lptport, PPFCONTROL, &output);
}

int lptport_setdata(uint8_t data)
{
	return ioctl(lptport, PPWDATA, &data);
}	
