
#include <windows.h>
#include <stdint.h>
#include <stdio.h>
#include <conio.h>

// these seem to be nowhere in the headers, hope they are correct :/
int _outp( unsigned port, int datab );
int _inp( unsigned port );

//#define DEBUG_LPTPORT

#ifdef DEBUG_LPTPORT
#define dbgprintf(_x_)	printf _x_
#else
#define dbgprintf(_x_)
#endif

static int PP_DATA=0x378;
static int PP_STATUS=0x379;
static int PP_CTRL=0x37a;

// check the OS which GIVEIO should be necessary
static int is_winnt(void)
{
	OSVERSIONINFO osvi;

	osvi.dwOSVersionInfoSize = sizeof(osvi);
	if( !GetVersionEx(&osvi) )
		return 0;

	switch (osvi.dwPlatformId)
	{
		case VER_PLATFORM_WIN32_NT:
			return 1;
		case VER_PLATFORM_WIN32_WINDOWS:
			return 0;
		case VER_PLATFORM_WIN32s:
			return 0;
	}

	/* unknown */
	return 0;
}

int lptport_init(void)
{
int port=0x378;	
	
	PP_DATA=port;
	PP_STATUS=port+1;
	PP_CTRL=port+2;
 
	if( is_winnt() ) 
	{
		// #################################################################
		//  So we are in WinNT, Win2000 or WinXP, we need to open and close
		//     the GIVEIO device. This should give us direct I/O access.  
		// #################################################################
	
		HANDLE h = CreateFile("\\\\.\\giveio", GENERIC_READ, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	
		if(h == INVALID_HANDLE_VALUE) 
		{
			dbgprintf((" Driver error: Could not access the GIVEIO device!\n"));
			return(-1);
		}
	
		CloseHandle(h);
	}
	return 1; 
}

int lptport_close(void)
{
	return 1;
}

int lptport_getstatus_busy(void)
{
	uint8_t inbit;
	inbit=(_inp(PP_STATUS)&0x80)>>7;
	return inbit;
}

int lptport_setcontrol_strobe(int outbit)
{
	uint8_t ctrl;
	ctrl=_inp(PP_CTRL);
	ctrl&=~(1<<0);
	ctrl|=(outbit<<0);
	_outp(PP_CTRL,ctrl);
	return 1;
}

int lptport_setcontrol_autofeed(int outbit)
{
	uint8_t ctrl;
	ctrl=_inp(PP_CTRL);
	ctrl&=~(1<<1);
	ctrl|=(outbit<<1);
	_outp(PP_CTRL,ctrl);
	return 1;
}

int lptport_setdata(uint8_t data)
{
	_outp( PP_DATA, data );
	return 1;
}	
 
